From c2bbd952d2dee6005562d309e10855b177610463 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jul 30 2020 01:17:19 +0000
Subject: [PATCH 661/2232] Add rust::String(const char *, size_t) constructor


---

diff --git a/include/cxx.h b/include/cxx.h
index f211b3b..5a33a7a 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -29,6 +29,7 @@ public:
 
   String(const std::string &);
   String(const char *);
+  String(const char *, size_t);
 
   String &operator=(const String &) noexcept;
   String &operator=(String &&) noexcept;
diff --git a/src/cxx.cc b/src/cxx.cc
index eb86d3d..8614d39 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -55,16 +55,11 @@ String::String(String &&other) noexcept {
 
 String::~String() noexcept { cxxbridge03$string$drop(this); }
 
-String::String(const std::string &s) {
-  auto ptr = s.data();
-  auto len = s.length();
-  if (!cxxbridge03$string$from(this, ptr, len)) {
-    panic<std::invalid_argument>("data for rust::String is not utf-8");
-  }
-}
+String::String(const std::string &s) : String(s.data(), s.length()) {}
+
+String::String(const char *s) : String(s, std::strlen(s)) {}
 
-String::String(const char *s) {
-  auto len = std::strlen(s);
+String::String(const char *s, size_t len) {
   if (!cxxbridge03$string$from(this, s, len)) {
     panic<std::invalid_argument>("data for rust::String is not utf-8");
   }

